// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function CreateLinearCongruentialGeneratorNumericalRecipes(seed){
  return CreateLinearCongruentialGeneratorCustom(Math.pow(2, 32), 1664525, 1013904223, seed);
}
function CreateLinearCongruentialGeneratorCustom(modulus, multiplier, increment, seed){
  var lcg;

  lcg = {};
  lcg.m = modulus;
  lcg.a = multiplier;
  lcg.c = increment;
  lcg.x = seed;

  return lcg;
}
function LinearCongruentialGeneratorNextNumber(lcg){
  lcg.x = Math.floor((lcg.a*lcg.x + lcg.c)%lcg.m);
  return lcg.x/lcg.m;
}
function CreatePseudorandomNumberGenerator(seed){
  var prg;

  prg = {};
  prg.lcg = CreateLinearCongruentialGeneratorNumericalRecipes(seed);

  return prg;
}
function PseudorandomNextNumber(prg){
  return LinearCongruentialGeneratorNextNumber(prg.lcg);
}
function PseudorandomNextInteger(prg, n){
  return Math.floor(PseudorandomNextNumber(prg)*n);
}
function PseudorandomNextIntegerBetween(prg, a, b){
  return Math.ceil(a) + Math.floor(PseudorandomNextNumber(prg)*(b - a));
}
function test(){
  var i, failures;
  var prg;

  failures = 0;

  prg = CreatePseudorandomNumberGenerator(12312312542);

  for(i = 0; i < 100; i = i + 1){
    PseudorandomNextNumber(prg);
  }

  return failures;
}


module.exports = {
	CreateLinearCongruentialGeneratorNumericalRecipes: CreateLinearCongruentialGeneratorNumericalRecipes,
	CreateLinearCongruentialGeneratorCustom: CreateLinearCongruentialGeneratorCustom,
	LinearCongruentialGeneratorNextNumber: LinearCongruentialGeneratorNextNumber,
	CreatePseudorandomNumberGenerator: CreatePseudorandomNumberGenerator,
	PseudorandomNextNumber: PseudorandomNextNumber,
	PseudorandomNextInteger: PseudorandomNextInteger,
	PseudorandomNextIntegerBetween: PseudorandomNextIntegerBetween,
	test: test
};